/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.estudiante.asistencia;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.GregorianCalendar;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import logica.Listas;
import logica.Search;
import orm.Curso;
import orm.Estudiante;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "AsistenciasServlet", urlPatterns = {"/AsistenciasServlet"})
public class AsistenciasServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        HttpSession session = request.getSession(false);
        if (session != null) {
            session.invalidate();
        }
        String cursoSelected = request.getParameter("cursoSelected");
        String estudianteSelected = request.getParameter("estudianteSelected");

        Curso curso;
        if (cursoSelected != null) {
            curso = Search.buscarCurso(Integer.parseInt(cursoSelected.split("-")[0]), cursoSelected.split("-")[1]);
        } else {
            Curso[] cursos = Search.buscarCursos();
            if (cursos != null) {
                curso = cursos[0];
            } else {
                curso = null;
            }
        }

        Estudiante estudiante;
        if (estudianteSelected != null) {
            estudiante = Search.buscarEstudiante(estudianteSelected);
        } else {
            if (curso != null) {
                Estudiante[] estudiantes = Search.buscarEstudiantes(curso);
                if (estudiantes != null) {
                    estudiante = estudiantes[0];
                } else {
                    estudiante = null;
                }
            } else {
                estudiante = null;
            }
        }

        String[] listaCurso = Listas.listaCursos();
        String[][] listaEstudiante = Listas.listaEstudiantes(curso);
        String[][] listaAsistencia = Listas.listaAsistencia(estudiante);
        Date date = new GregorianCalendar().getTime();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");

        request.setAttribute("listaAsistencia", listaAsistencia);
        request.setAttribute("now", format.format(date));
        request.setAttribute("listaCurso", listaCurso);
        request.setAttribute("listaEstudiante", listaEstudiante);
        request.setAttribute("cursoSelected", cursoSelected);
        request.setAttribute("estudianteSelected", estudianteSelected);
        request.getRequestDispatcher("asistencias.jsp").forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
